package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.TransactionBody;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: TransactionType
// UnionValue: CreateTokenAccount

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("CreateTokenAccount")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class CreateTokenAccount implements TransactionBody {
	public final TransactionType type = TransactionType.CREATE_TOKEN_ACCOUNT;
	private Url url;
	private Url tokenUrl;
	private Url[] authorities;
	private TokenIssuerProof proof;

    //
	public Url getUrl() {
	    return url;
	}
	public void setUrl(final Url value) {
	    this.url = value;
	}

	public CreateTokenAccount url(final Url value) {
	    setUrl(value);
	    return this;
	}
	public CreateTokenAccount url(final String value) {
	    setUrl(Url.toAccURL(value));
	    return this;
	}
	public Url getTokenUrl() {
	    return tokenUrl;
	}
	public void setTokenUrl(final Url value) {
	    this.tokenUrl = value;
	}

	public CreateTokenAccount tokenUrl(final Url value) {
	    setTokenUrl(value);
	    return this;
	}
	public CreateTokenAccount tokenUrl(final String value) {
	    setTokenUrl(Url.toAccURL(value));
	    return this;
	}
	public Url[] getAuthorities() {
	    return authorities;
	}
	public void setAuthorities(final Url[] value) {
	    this.authorities = value;
	}

	public CreateTokenAccount authorities(final Url[] value) {
	    setAuthorities(value);
	    return this;
	}
	public TokenIssuerProof getProof() {
	    return proof;
	}
	public void setProof(final TokenIssuerProof value) {
	    this.proof = value;
	}

	public CreateTokenAccount proof(final TokenIssuerProof value) {
	    setProof(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.url == null)) {
            marshaller.writeUrl(2, this.url);
        }
        if (!(this.tokenUrl == null)) {
            marshaller.writeUrl(3, this.tokenUrl);
        }
        if (!(this.authorities == null || this.authorities.length == 0)) {
            marshaller.writeUrl(7, this.authorities);
        }
        if (!(this.proof == null)) {
            marshaller.writeValue(8, proof);
        }
        return marshaller.array();
    }
}
